varying vec3 L;
varying vec3 P;
varying vec3 N;

uniform vec4 color0;    // Material Color: 0.8, 0.0, 0.0, 1.0
uniform vec4 color1;    // Silhouette Color: black
uniform vec4 color2;    // Specular Color: 0.8, 0.0, 0.0, 1.0

uniform sampler2D myTexture;


#define shininess 20.0



void main (void)
{
	// Lighting
	vec3 eyePos = vec3(0.0,0.0,5.0);
	vec3 EyeVert = normalize(eyePos - P);
	vec3 EyeLight = normalize(L + EyeVert);


	// Simple Silhouette
	float sil = dot(N,EyeVert);
	if (sil < 0.1) {
	
		gl_FragColor = color1;
		
	} else {
	
		
		//gl_FragColor = texture2D(myTexture, vec2(gl_TexCoord[0]));
		//vec4 ccolor2 = gl_FragColor;
		//ccolor2 *= 1.8;
		
		gl_FragColor = color0 * smoothstep(0.0,0.2,sil);// * sil;
			
		// Specular part
		float spec = pow(max(dot(N,EyeLight),0.0), shininess);

		if (spec < 0.2) gl_FragColor *= 0.8;//1.5;//0.8
		else gl_FragColor = color2; 
		//else gl_FragColor = ccolor2;
			
		gl_FragColor += color2 * smoothstep(0.1,0.4,spec);
		gl_FragColor += color2 * step(0.4,spec);
		
		gl_FragColor += spec;  // advanced 3D Toon

		// Diffuse part
		float diffuse = max(dot(N,L),0.0);
		if (diffuse < 0.5) gl_FragColor *= 0.8;//1.0;//0.8
	}
	
	
	
	
	gl_FragColor = vec4(N,1.0);
}