uniform vec3 t3d_camera_pos; // Camera position

varying vec3 position;       // Object position of the vertex
varying vec3 camera_dir;     // Direction of the camera
varying mat3 tangent_mat;    // The tangent matrix

//attribute vec3 tangent;

void main()
{
	gl_TexCoord[0] = gl_MultiTexCoord0;
	gl_Position    = ftransform();
	position       = gl_Vertex;
	camera_dir     = normalize(t3d_camera_pos - gl_Vertex);

	// Compute tangent matrix (gl_MultiTexCoord2 - tangent vectors)
	//
	//       [Tx, Ty, Tz]
	//   M = [Nx, Ny, Nz]
	//       [Bx, By, Bz]
	//
	vec3 n = normalize(gl_Normal);
	vec3 t = normalize(gl_MultiTexCoord2.xyz);
	vec3 b = normalize(cross(n,t));
	tangent_mat = mat3(t,b,n);
}
