uniform vec3 t3d_camera_pos;

mat3 GetLinearPart(mat4 m)
{
	mat3 result;
	
	result[0][0] = m[0][0]; 
	result[0][1] = m[0][1]; 
	result[0][2] = m[0][2]; 

	result[1][0] = m[1][0]; 
	result[1][1] = m[1][1]; 
	result[1][2] = m[1][2]; 
	
	result[2][0] = m[2][0]; 
	result[2][1] = m[2][1]; 
	result[2][2] = m[2][2]; 
	
	return result;
}		
			   
void main()
{	
/*
	mat4 ModelWorld4x4_1 = mat4(1,0,0,2,
	                            0,1,0,1,
	                            0,0,1,-11,
	                            0,0,0,1);
*/
	   
	// Model matrix should be passed normally!                       
	mat4 ModelWorld4x4_2 = mat4(1,0,0,0,
	                            0,1,0,0,
	                            0,0,1,0,
	                            2,1,-11,1);
	           
	gl_Position = ftransform();		
	//gl_TexCoord[0] = gl_MultiTexCoord0 * 2.0;
	           
	// Model matrix                 
	mat4 ModelWorld4x4 = ModelWorld4x4_2;
	mat3 ModelWorld3x3 = GetLinearPart(ModelWorld4x4);
	
	// Compute stuff
	vec3 postion = (ModelWorld4x4 * gl_Vertex).xyz;
	vec3 normal  = normalize(ModelWorld3x3 * gl_Normal);
	vec3 eye_dir = normalize(postion - t3d_camera_pos);
		
	// Reflect the normal along the eye direction in worldspace
	gl_TexCoord[1].xyz = reflect(eye_dir,normal); 
}
