
//---------------------------------------------------------------------------
// Fragment shader used for direct volume rendering with 3d texture
//---------------------------------------------------------------------------

uniform sampler1D transfer_tex; // The transfer function used
uniform sampler3D data_tex;     // The volume texture

void main (void)
{
   // Get the intensity
   vec4 data = texture3D(data_tex,vec3(gl_TexCoord[0]));
  
   // Discard zero intensity values (are background)
   if (data.w == 0.0) {
      discard;
   } else {
      // Look up gradient & color
      gl_FragColor = texture1D(transfer_tex,data.w);

      // Compute gradient magnitude
      float gradMagnitude = sqrt(data.x * data.x + data.y * data.y + data.z * data.z);

		gl_FragColor *= gradMagnitude;
   }
}
