uniform sampler2D decal_tex;
varying vec3 normal;
varying vec3 position;

void main()
{
	vec4 result = vec4(0,0,0,0);
	
	for (int i=0; i<2; ++i) {
		vec3 L = normalize(gl_LightSource[i].position.xyz - position); 
		vec3 E = normalize(-position);
		vec3 R = normalize(-reflect(L,normal)); 
		float dist = length(L);
		
		// Compute attanuation
		float atten = 1.0 / (gl_LightSource[i].constantAttenuation +
								   gl_LightSource[i].linearAttenuation    * dist +
								   gl_LightSource[i].quadraticAttenuation * dist * dist);
		
		// Ambient
		vec4 Iamb = gl_LightSource[i].ambient * gl_FrontMaterial.ambient;
		
		// Diffuse
		vec4 Idiff = (gl_LightSource[i].diffuse * max(dot(normal,L), 0.0)) * gl_FrontMaterial.diffuse;
		
		// Specular
		vec4 Ispec = gl_FrontMaterial.specular * pow(max(dot(R,E),0.0),gl_FrontMaterial.shininess);
		
		// Combine all
		result += gl_FrontMaterial.emission + Iamb + atten * (gl_FrontMaterial.ambient + Idiff + Ispec);
	}
	
	// Finally combine color with texture
	gl_FragColor = result * texture2D(decal_tex,vec2(gl_TexCoord[0]));
}
